package org.netkernel.doc.endpoint;

import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;


/**
 * This engine will return the enclosed text in markup that will
 * render it in a call-out box.
 */


public class CalloutEngine extends StandardAccessorImpl
  {
  public CalloutEngine()
    {
    this.declareThreadSafe();
    }


  @Override
  public void onSource(INKFRequestContext aContext) throws Exception
    {
    String type = aContext.getThisRequest().getArgumentValue("activeType");
    String operandValue = aContext.source("arg:operand", String.class);

    if (type.endsWith("XHTML"))
      {
      // XHTML
		INKFRequest request = aContext.createRequest("active:wikiParser/XHTML");
	    request.addArgumentByValue("operand", operandValue);
	    request.addArgument("base", ".");
	    request.setRepresentationClass(String.class);
	    String content = (String) aContext.issueRequest(request);
      aContext.createResponseFrom("<div class=\"bookcallout\">" + content + "</div>");
      }
    else
      {  //Docbook
      aContext.createResponseFrom("<note><![CDATA[" + operandValue + "]]></note>");
      }
    }

  }
